'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
/* global window, requestAnimationFrame */

var fadeIn = function fadeIn(el, display) {
  var tmpEl = el;
  var opacity = 0;

  tmpEl.style.display = display || window.getComputedStyle(tmpEl, null).getPropertyValue('display') || 'block';
  tmpEl.style.opacity = 0;
  tmpEl.style.filter = '';

  var last = +new Date();
  var anim = void 0;
  var tick = function tick() {
    opacity += (new Date() - last) / 400;
    tmpEl.style.opacity = opacity;
    tmpEl.style.filter = 'alpha(opacity=' + (100 * opacity | 0) + ')'; // eslint-disable-line no-bitwise

    last = +new Date();

    if (opacity < 1) {
      // eslint-disable-next-line no-unused-expressions
      anim = window.requestAnimationFrame && requestAnimationFrame(tick) || setTimeout(tick, 16);
    } else {
      window.cancelAnimationFrame && cancelAnimationFrame(anim) || clearTimeout(anim);
      tmpEl.style.display = display || window.getComputedStyle(tmpEl, null).getPropertyValue('display') || 'block';
    }
  };

  tick();
};

var fadeOut = function fadeOut(el) {
  var tmpEl = el;
  var opacity = 1;

  tmpEl.style.opacity = 1;
  tmpEl.style.filter = 'alpha(opacity=' + (100 * opacity | 1) + ')'; // eslint-disable-line no-bitwise

  var last = +new Date();
  var anim = void 0;
  var tick = function tick() {
    opacity -= (new Date() - last) / 400;
    tmpEl.style.opacity = opacity;
    tmpEl.style.filter = 'alpha(opacity=' + (100 * opacity | 0) + ')'; // eslint-disable-line no-bitwise

    last = +new Date();

    if (opacity <= 0) {
      window.cancelAnimationFrame && cancelAnimationFrame(anim) || clearTimeout(anim);
      tmpEl.style.display = 'none';
    } else {
      // eslint-disable-next-line no-unused-expressions
      anim = window.requestAnimationFrame && requestAnimationFrame(tick) || setTimeout(tick, 16);
    }
  };

  tick();
};

var fadeOutIn = function fadeOutIn(elOut, elIn, opts) {
  fadeOut(elOut);
  fadeIn(elIn, opts.display);
};

exports.default = null;
exports.fadeIn = fadeIn;
exports.fadeOut = fadeOut;
exports.fadeOutIn = fadeOutIn;